/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* Copyright 2013 - 2020, nymea GmbH
* Contact: contact@nymea.io
*
* This file is part of maveo-scanner.
* This project including source code and documentation is protected by
* copyright law, and remains the property of nymea GmbH. All rights, including
* reproduction, publication, editing and translation, are reserved. The use of
* this project is subject to the terms of a license agreement to be concluded
* with nymea GmbH in accordance with the terms of use of nymea GmbH, available
* under https://nymea.io/license
*
* For any further details and any questions please contact us under
* contact@nymea.io or see our FAQ/Licensing Information on
* https://nymea.io/license/faq
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef HONEYWELLREQUEST_H
#define HONEYWELLREQUEST_H

#include <QByteArray>

#include "maveoscannerutils.h"

class LIBMAVEO_SCANNER_EXPORT HoneywellRequest
{
public:
    enum Storage {
        StorageVolatile,
        StorageNonVolatile
    };

    HoneywellRequest(const QByteArray prefix, const QByteArray &command, const QByteArray &data = QByteArray(), Storage storage = StorageNonVolatile);

    QByteArray prefix() const;
    QByteArray command() const;
    QByteArray data() const;
    Storage storage() const;

    QByteArray requestData() const;

    static QByteArray createPrefix(char target = 'm', char join = '\r');

private:
    QByteArray m_prefix;
    QByteArray m_command;
    QByteArray m_data;
    Storage m_storage = StorageNonVolatile;

};

#endif // HONEYWELLREQUEST_H
